Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

cam = CreateCamera()
PositionEntity cam,0,50,-50
TurnEntity cam,30,0,0

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()

Global PressPapierMesh = LoadMesh("PressPapier.b3d")
HideEntity PressPapierMesh

HullMesh = LoadMesh("PressPapierPhys.b3d")
Global PressPapierHull = BodyCreateHull(HullMesh, 1)
pxBodySetFlagCollision(PressPapierHull, 0)
FreeEntity HullMesh

Global PotMesh = LoadMesh("Pot.b3d")
HideEntity PotMesh

PotMeshPhys = LoadMesh("PotPhys.b3d")
Global PotHull = BodyCreateMesh(PotMeshPhys, 0)
pxBodySetFlagCollision(PotHull, 0)
FreeEntity PotMeshPhys

Repeat

If KeyHit(57) Then CreatepxBody(0,20,0,1)
If KeyHit(15) Then CreatepxBody(0,10,0,2)

pxRenderPhysic(60,0)
UpdatepxBodies()

RenderWorld()
Flip

Until KeyHit(1)
End

Type pxBody
	Field mesh
	Field body
End Type

Function UpdatepxBodies()
	For pxB.pxBody = Each pxBody
		pxBodySetEntity pxB\mesh, pxB\body
	Next
End Function

Function CreatepxBody(x#,y#,z#, fig = 0)	
	pxB.pxBody = New pxBody
	
	If fig = 0 Then fig = Rand(1,2)
	Select fig
		Case 1 ; -
			pxB\mesh = CopyEntity(PressPapierMesh)
			EntityColor pxB\mesh, Rnd(0,255), Rnd(0,255), Rnd(0,255)
			pxB\body = pxCopyBody(PressPapierHull)
			
		Case 2 ; 
			pxB\mesh = CopyEntity(PotMesh)
			pxB\body = pxCopyBody(PotHull)
	End Select
	pxBodySetPosition pxB\body,x,y,z
End Function

Function BodyCreateHull%(mesh%, mass#)

	Local nsurf = CountSurfaces(mesh)
	Local nvert = 0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nvert = nvert + CountVertices(surf)
	Next
	     vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			 PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			 PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			 PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	Local bbb%= pxBodyCreateHull(vbank, nvert, mass)
	FreeBank vbank
	Return bbb
End Function

Function BodyCreateMesh(mesh%, mass# = 0)
	nsurf = CountSurfaces(mesh)
	nvert = 0
	nface=0
	For ns = 1 To nsurf
		Local surf = GetSurface(mesh,ns)
		nface = nface+CountTriangles(surf)
		nvert = nvert +CountVertices(surf)
	Next

	fbank = CreateBank(nface*4*3)
	nf = 0
	vbank = CreateBank(nvert*4*3)
	nv = 0
	For ns = 1 To nsurf
		surf = GetSurface(mesh,ns)
		nfv = CountTriangles(surf)
		For nfc = 0 To nfv -1
			PokeInt fbank,nf*12+0,TriangleVertex(surf,nfc,0)
			PokeInt fbank,nf*12+4,TriangleVertex(surf,nfc,1)
			PokeInt fbank,nf*12+8,TriangleVertex(surf,nfc,2)
			nf=nf+1
		Next

		nvv = CountVertices(surf)
		For nvc = 0 To nvv - 1
			PokeFloat vbank,nv*12+0,VertexX(surf,nvc)
			PokeFloat vbank,nv*12+4,VertexY(surf,nvc)
			PokeFloat vbank,nv*12+8,VertexZ(surf,nvc)
			nv = nv+1
		Next
	Next
	bbb%=pxCreateTriMesh(vbank, fbank, nvert, nface,mass)
	FreeBank vbank
	FreeBank fbank
	Return bbb%
End Function